#include "CreateBar.h"
#include "Glob.h"
#include "Object.h"
#include "BarButton.h"

#include <iostream>

extern Glob* glob;

sfg::Window::Ptr CreateBar::GetPointer()
{
	return m_Window;
}

bool CreateBar::Init()
{
	m_Window = sfg::Window::Create(2);
 	m_Window->SetTitle(" ");
	m_Window->SetPosition(sf::Vector2f(glob->resolution.x-64,64));
	m_Window->SetRequisition(sf::Vector2f(64,glob->resolution.y));
	m_Window->SetClass( "vbar" );
	
	m_Box = sfg::Box::Create( sfg::Box::VERTICAL, 5.0f );
	
	for (std::vector<BarButton*>::iterator it = buttons.begin(); it!=buttons.end(); ++it)
		m_Box->Pack( (*it)->m_Button, false );
	
	m_Window->Add(m_Box);
	
	AddNewButton();
	
	return true;
}

void CreateBar::PokeButton(int index)
{
	if (index < buttons.size())
	{
		if (buttons[index]->m_Obj->m_Rooms[0]->Type == NEW)
		{
			glob->event->NewButtonPoked(buttons[index]);
		}
		else
		{
			buttons[index]->OnClick();
		}
	}
}

BarButton* CreateBar::AddNewButton()
{
	Object* bObj;
	BarButton* button;
	
	bObj = new Object();
	bObj->m_Rooms.push_back(new Room(NEW));
	bObj->m_KnownEnemies = glob->world->GetHumanPlayer()->m_KnownEnemies;
	bObj->m_Name = "~new";
	button = new BarButton();
	button->m_Button->SetLabel(bObj->m_Name);
	button->m_Obj = bObj;
	button->m_Index = buttons.size();
	buttons.push_back( button );
	
	m_Box->Pack( button->m_Button, false );
	
	return button;
}

void CreateBar::RemoveButton(int index)
{
	if (index < buttons.size())
	{
		buttons[index]->m_Button->Show(false);
		m_Box->Remove(buttons[index]->m_Button);
		buttons.erase(buttons.begin()+index);
	}
	
	for (int i=0; i<buttons.size();++i)
	{
		buttons[i]->m_Index = i;
	}
}

void CreateBar::RemoveNewButton()
{
	if (buttons.size() == 0) return;
	
	std::vector<BarButton*>::iterator newb = buttons.end();
	if ((*newb)->m_Obj->m_Rooms[0]->Type == NEW)
	{
		RemoveButton(buttons.size()-1);
	}
}