#include "NotificationBar.h"
#include "Glob.h"
#include "BarButton.h"

#include <iostream>

extern Glob* glob;

sfg::Window::Ptr NotificationBar::GetPointer()
{
	return m_Window;
}

bool NotificationBar::Init()
{
	m_Window = sfg::Window::Create(2);
 	m_Window->SetTitle(" ");

	m_Window->SetRequisition(sf::Vector2f(64,glob->resolution.y));
	m_Window->SetClass( "vbar" );
	
	m_Box = sfg::Box::Create( sfg::Box::VERTICAL, 5.0f );
	m_Window->Add(m_Box);
	
	// Create a vertical box layouter with 5 pixels spacing and add the label
	// and button to it.
	
	//for (std::vector<BarButton*>::iterator it = buttons.begin(); it!=buttons.end(); ++it)
	//	m_Box->Pack( (*it)->m_Button, false );

	
	return true;
}

void NotificationBar::PokeNotification(int index)
{
	if (index < buttons.size())
	{
		buttons[index]->OnClick();
	}
}

void NotificationBar::RemoveNotification(int index)
{
	if (index < buttons.size())
	{
		buttons[index]->m_Button->Show(false);
		m_Box->Remove(buttons[index]->m_Button);
		buttons.erase(buttons.begin()+index);
	}
	
	for (int i=0; i<buttons.size();++i)
	{
		buttons[i]->m_Index = 100+i;
	}
}

void NotificationBar::NewMessage(std::string shorttext, std::string longtext)
{
	BarButton* button = new BarButton();
	button->m_Button->SetLabel(shorttext);
	button->m_NoteString = longtext;
	button->m_Index = 100 + buttons.size();
	buttons.push_back(button);
	
	m_Box->Pack(button->m_Button,false);
}