#ifndef OBJECT_H
#define OBJECT_H

#include <SFML/Graphics.hpp>
#include <vector>

enum RoomType
{
	PLAYERLAIR,
	PLAYERBASE,
	LOOK,
	FORAGE,
	ROCK,
	BPAPER,
	XSCISSORS,
	TEMPLATE,
	CREATE,
	PING,
	FRIENDPING,
	RELAY,
	WFRIENDRELAY,
	SNOOP,
	ASCREAM,
	ASEEKSCREAM,
	KCHARGE,
	MEANDER,
	DECOY,
	PINGFAKE,
	NEW
};

struct Room
{
	Room(RoomType);
	Room(RoomType,sf::FloatRect);
	RoomType Type;
	sf::FloatRect Rect;
};

struct Object
{
	Object();
	std::vector<Room*> m_Rooms;
	std::vector<Object*> m_NewKnownEnemies;
	std::vector<Object*> m_KnownEnemies;
	Object* m_Template;
	sf::Vector2f m_Position;
	int m_PlayerID;
	std::vector<int> m_RevealedToPlayers;
	float m_VisibleToPlayer;
	std::string m_Name;
	bool m_Alive;
	bool m_Visible;
	
	bool TryPosition(sf::Vector2f);
	void ShufflePosition();
	Object* Spawn();
};

RoomType CharToRoomType(char);
char RoomTypeToChar(RoomType);
std::string RoomTypeToName(RoomType);

#endif