#include "Render.h"

#include <iostream>

extern Glob* glob;

bool Render::Init()
{
	m_RenderWindow.create( sf::VideoMode( glob->resolution.x, glob->resolution.y ), "World map test", sf::Style::None);// | sf::Style::Titlebar | sf::Style::Close );
	m_RenderWindow.resetGLStates();
	
	m_Desktop.LoadThemeFromFile( "Themes/LurkUnderWires.theme" );
	
	return true;
}

bool Render::Loop()
{
	if ( !m_RenderWindow.isOpen() )
	{
		return false;
	}
	
	while( m_RenderWindow.pollEvent( m_Event ) ) 
	{
		m_Desktop.HandleEvent( m_Event );

		// If window is about to be closed, leave program.
		if( m_Event.type == sf::Event::Closed ) {
			m_RenderWindow.close();
		}
		
		if (m_Event.type == sf::Event::KeyPressed && m_Event.key.code == sf::Keyboard::Escape)
		{
			m_RenderWindow.close();
		}
		
		if (m_Event.type == sf::Event::KeyPressed)
		{
			glob->event->KeyPressed(m_Event.key);
		}
	}

	// Update SFGUI with elapsed seconds since last call.
	m_Desktop.Update( m_Clock.restart().asSeconds() );

	// Rendering.
	m_RenderWindow.clear();
	m_GUI.Display( m_RenderWindow );
	m_RenderWindow.display();
	
	return true;
}

bool Render::Register(sfg::Window::Ptr window)
{
	m_Desktop.Add(window);
}

void Render::BringToFront(sfg::Window::Ptr window)
{
	m_Desktop.BringToFront(window);
}