#include "RogueButton.h"
#include "RogueWindow.h"
#include "Glob.h"

#include <iostream>

void RogueButton::OnClick()
{
	m_RogueWindow->OnButtonClick(this);
}

void RogueButton::OnRightClick()
{
	m_RogueWindow->OnButtonRightClick(this);
}

void RogueButton::Init(RogueWindow* rw, char ch)
{
	m_ButtonChar = ch;
	m_RogueWindow = rw;
	
	m_Button = sfg::Button::Create(ch);
	m_Button->SetClass( "available" );
	m_Button->GetSignal( sfg::Widget::OnLeftClick ).Connect( &RogueButton::OnClick, this );
	m_Button->GetSignal( sfg::Widget::OnRightClick ).Connect( &RogueButton::OnRightClick, this );
	
	m_choose = false;
	m_pos = sf::Vector2i(0,0);
	
}

void RogueButton::NewChar(char ch)
{
	m_Button->SetLabel(ch);
	m_ButtonChar = ch;
}