#ifndef ROGUEWINDOW_H
#define ROGUEWINDOW_H

#include <stdlib.h>
#include <vector>

#include <SFGUI/SFGUI.hpp>
#include <SFML/Graphics.hpp>

#include "RogueButton.h"
#include "Object.h"

class CreateBar;
class BarButton;

struct DungeonRoom
{
	sf::IntRect space;
	RoomType type;
};

class RogueWindow
{
public:
	sfg::Window::Ptr GetPointer();
	bool Init(CreateBar*);
	void OnButtonClick(RogueButton*);
	void OnButtonRightClick(RogueButton*);
	
	Object* GetCurrentObject();
	void Clear();
	
	void Show(bool);
	
	RoomType m_CurrentRoomType;
	
	BarButton* m_TargetButton;
	
	void Inventory();
	void Delete();
	void Spawn();
	
private:
	sfg::Window::Ptr m_Window;
	
	sfg::Box::Ptr m_RoomChooseBar;
	sfg::Table::Ptr m_Dungeon;
	
	sfg::Label::Ptr m_Description;
	sfg::Button::Ptr m_bInventory;
	sfg::Button::Ptr m_bDelete;
	sfg::Button::Ptr m_bSpawn;
	
	sfg::Box::Ptr m_Contains;
	sfg::Box::Ptr m_FirstRow;
	sfg::Fixed::Ptr m_SecondRow;
	
	std::vector<RogueButton*> m_RogueButtons;
	std::vector<RogueButton*> m_ChooseButtons;
	
	std::vector< DungeonRoom* > m_DungeonRooms;
	
	CreateBar* m_CreateBar;
	
	void RefreshAvailableRooms();
	void InitDungeon();
	
	void AddRoomAt(sf::Vector2i);
	void RemoveRoomAt(sf::Vector2i);
	void RefreshDungeon();
	
	std::vector<int> m_shuffledints;
	int DRand(int,int);
	void DrawCorridor(sf::IntRect,sf::IntRect);
};

#endif