#include "Stat.h"
#include "World.h"
#include "Glob.h"

#include <string>
#include <sstream>

extern Glob* glob;

sfg::Window::Ptr Stat::GetPointer()
{
	return m_Window;
}

bool Stat::Init()
{
	m_Window = sfg::Window::Create(2);
 	m_Window->SetTitle(" ");
	m_Window->SetPosition( sf::Vector2f(glob->resolution.x-148,0) );
	m_Window->SetClass( "stat" );
	m_Window->SetRequisition( sf::Vector2f(148,64));
	
	m_BoxH = sfg::Box::Create(sfg::Box::HORIZONTAL);
	m_BoxCol1 = sfg::Box::Create(sfg::Box::VERTICAL);
	m_BoxCol2 = sfg::Box::Create(sfg::Box::VERTICAL);
	m_lBase = sfg::Label::Create("Enemies:");
	m_lBaseNum = sfg::Label::Create("2");;
	m_lRisk = sfg::Label::Create("Risk:");
	m_lRiskNum = sfg::Label::Create("100");

	m_lBase->SetClass( "stat" );
	m_lRisk->SetClass( "stat" );
	m_lBaseNum->SetClass( "stat" );
	m_lRiskNum->SetClass( "stat" );
	
	m_BoxCol1->Pack(m_lBase);
	m_BoxCol1->Pack(m_lRisk);
	m_BoxCol2->Pack(m_lBaseNum);
	m_BoxCol2->Pack(m_lRiskNum);
	
	m_BoxH->Pack(m_BoxCol1);
	m_BoxH->Pack(m_BoxCol2);
	
	m_Window->Add( m_BoxH );
	
	return true;
}

void Stat::SetPosition(sf::Vector2f pos)
{
	m_Window->SetPosition(pos);
}

void Stat::Update()
{
	std::stringstream risk;
	risk << glob->world->GetHumanPlayer()->m_Risk;
	m_lRiskNum->SetText(risk.str());
	
	std::stringstream bases;
	bases << glob->world->GetNoOfEnemies();
	m_lBaseNum->SetText(bases.str());
	
}